# BROKEN ACCESS CONTROL

## Explanation

There’s a cookie which value is MD5 hash of `false` (`68934a3e9455fa72420237eb05902327`)

We have to replace it by the MD5 hash of `true` (`b326b5062b2f0e69046810717534cb09`) and send a request to get the flag

## Exploitation

**This vulnerability ranks number 5 in OWASP's top 10 Web Application Security Risk**

> Metadata manipulation, such as :
>  - replaying or tampering with a JSON Web Token (JWT) access control token
>  - tampering with a cookie
>  - manipulate a hidden field to elevate privileges
>  - abusing JWT invalidation.

This vulnerability is for the user to modify something somewhere manually to bypass access control.

## Prevention

> _Access control is only effective if enforced in trusted server-side code or server-less API, where the attacker cannot modify the access control check or metadata._
>  - _Disable web server directory listing and ensure file metadata (e.g. .git) and backup files are not present within web roots._
>  - _JWT tokens should be invalidated on the server after logout._
>  - _With the exception of public resources, deny by default._

## Documentation

- [OWASP - Broken Access Control](https://owasp.org/www-community/Broken_Access_Control)
- [OWASP - TOP 10 - Broken Access Control](https://owasp.org/www-project-top-ten/2017/A5_2017-Broken_Access_Control)