# HTPASSWD DISCLOSURE

## Explanation

With the utilitary DIRSEARCH, I found two interesting directories (one that the robots.txt pointed out as well)

git clone https://github.com/maurosoria/dirsearch
utilitary to search accessible directories on the server

/images **/admin** /audio /css /includes /js /fonts /errors **/whatever**

All directories output a 403 - Forbidden when browsed to except /admin /whatever

- /whatever
  - contains .htpasswd file, which contains a login / password couple
    - root:8621ffdbc5698829397d97767ac13db3
    - `8621ffdbc5698829397d97767ac13db3` is MD5 hash of `dragon`

- /admin
  - route prompts for a login and password.
    - login = root
    - password = dragon

We get the flag

## Exploitation

On Apache servers .htpasswd/.htaccess files are used to restrict areas of the server through the use of HTTP basic authentication.
  - If a remote unauthenticated attacker can download these files, he can potentially discover important information.
    - => Protected areas of the server if he downloads .htaccess
    - => username/password to access those areas if he downloads .htpasswd

Here the server is nginx, the .htpasswd/.htaccess/HTTP basic auth is only mocked for educational purposes.

## Prevention

> - Apache webservers should be properly configured to prevent .htaccess and .htpasswd files from being viewed by web clients.

## Documentation

[OWASP - apache configuration](https://wiki.owasp.org/index.php/SCG_WS_Apache#Restrict_access_to_.htaccess_files)