# UNRESTRICTED FILE UPLOAD

## Explanation

When sending form data through a POST HTTP request, content is encoded with multipart/form-data
  - => multipart/form-data itself is used to group multiple inputs, delimited by a boundary string
    - each subpart/inputs of the data have their own section header indicating the data type of the section
    - those types must be infered and added by the browser if not indicated.

Only files with image/jpeg type are accepted by the server
  - upload of a file with .jpg extension works fine
  - upload of a file with .php/.gif/.png extensions does not work for example

=> if we change the type (inside the multipart/form-data) of the input manually to “image/jpeg”, then we get the flag

A reflected xss was possible as well with this upload.
- `<svg onload=alert(1)>.jpg`

## Exploitation

> This vulnerability allows the attacker to upload code to the system.
> - The risk of this vulnerability is high
>   - high impact
>   - high probability of detection for the attacker)
> - Server-side attacks: The web server can be compromised by uploading and executing a web-shell which can :
>   - run commands
>   - browse system files
>   - browse local resources
>   - attack other servers
>   - exploit the local vulnerabilities
>   - etc.
> - Client-side attacks: Uploading malicious files can make the website vulnerable to client-side attacks such as :
>   - XSS
>   - Cross-site Content Hijacking
> - An attacker might be able to put a phishing page into the website or deface the website.
> - The file storage server might be abused to host troublesome files including malwares, illegal software, or adult contents.
> - Uploaded sensitive files might be accessible by unauthorised people.

## Prevention

> - Check the extension of the file
> - Check the type of the file in the multipart/form-data
> - Parse the file to verify it matches its extension/type
> - Limit the filename length
> - Isolated filesystem for uploaded files

## Documentation

- [OWASP - unrestricted file upload](https://owasp.org/www-community/vulnerabilities/Unrestricted_File_Upload)