# UNVALIDATED REDIRECTIONS

## Explanation

The website uses a custom route for redirecting user to other websites

It is specifically used for social media redirections
- index.php?page=redirect&site=facebook
- index.php?page=redirect&site=twitter
- index.php?page=redirect&site=instagram

- `http://VM_IP/?page=redirect&site=malicious` gets us the flag


## Exploitation

If a trusted website uses this redirection system, an attacker can use social engineering to have a victim click on the malicious url (pointing to the trusted website + redirecting to malicious website)

This malicious website could mock the login page of the trusted website to steal its credentials for example.

- The attacker then could impersonate the user to :
  - steal information
  - perform actions on his behalf
- It could also provide an entrypoint to the attacker to penetrate the system further. 

## Prevention

> - Avoid using redirects and forwards.
> - If used, do not allow the URL as user input for the destination.
> - Have the user provide short name/ID/token mapped server-side to a full target URL.
>    - Be careful that this doesn't introduce an enum vulnerability (attacker could cycle through IDs to find all possible redirect targets)
> - Sanitize input by creating a list of trusted URLs(should be allow-list rather than block list).
> - Force all redirects to first go through a page notifying users that they are going off of your site, with the destination clearly displayed, and have them click a link to confirm.

## Documentation

[OWASP - Unvalidated Redirects](https://cheatsheetseries.owasp.org/cheatsheets/Unvalidated_Redirects_and_Forwards_Cheat_Sheet.html)