# WEB PARAMETER TAMPERING

## Explanation

On the survey page
- HTML modification to input values other than 1-10.
  - => This results in the attacker being able to update the survey in a way he should not.
  - We get the flag

## Exploitation

*Web Parameter Tampering is a subset of Input Validation vulnerabilities*

> An attacker can for example :
> - Change price of an item on a e-commerce platform
> - Change profile id inside a url to debit the account of another user

## Prevention

> - Perform server side validations to validate the values sent against the authentication information
> - Implement input validation
>   - min/max value ranges for dates and numerical parameters
>   - min/max length for strings
>   - array of allowed values
>   - regular expressions
>     - allow lists
>     - block lists

## Documentation

[OWASP - Web Parameter Tampering](https://owasp.org/www-community/attacks/Web_Parameter_Tampering)
[OWASP - Input Validation](https://cheatsheetseries.owasp.org/cheatsheets/Input_Validation_Cheat_Sheet.html)