# WEBSERVER METAFILES

## Explanation

In its web security testing guide, OWASP recommands to check for metafiles on the webserver.

This part of the guide focuses mainly on the analysis of the robots.txt file, located at the root of the server file structure.

the content of darkly's webserver robots.txt file is

```
User-agent: *
Disallow: /whatever
Disallow: /.hidden
```

the /whatever directory already has been used for the _HTPASSWD DISCLOSURE_ vulnerability
the /.hidden directory contains links that point to links that point to links, with README files at the end of the chain.

We need to get all the README files, a flag might be in one of them.
A combination of wget and find commands gave the flag away.

## Exploitation

> This robots.txt file can contain usefull information for the attacker such as :
> - paths to test
> - technologies used

## Prevention

Carefully include information in the robots.txt file

## Documentation

- [OWASP - metafiles](https://owasp.org/www-project-web-security-testing-guide/stable/4-Web_Application_Security_Testing/01-Information_Gathering/03-Review_Webserver_Metafiles_for_Information_Leakage.html)