# STORED XSS

## Explanation

XSS literature tells us that the first stored XSS attacks were performed on guestbooks comment sections.

`<script>alert(1)<script>` in the comment input field of the feedback page gets us the flag

## Exploitation

**This vulnerability ranks number 7 in OWASP's top 10 Web Application Security Risk**

> - Stored XSS : _The server stores unsanitized user input that is viewed at a later time by another user or an administrator. Stored XSS is often considered a high or critical risk._

> XSS major risks are :
> - session stealing
> - account takeover
> - MFA bypass
> - DOM node replacement or defacement (such as trojan login panels)
> - attacks against the user’s browser such as malicious software downloads
> - key logging

## Prevention

Separate untrusted data from active browser content.
This can be achieved by:
- Using frameworks that automatically escape XSS by design (React.JS)
  - Learn the limitations of each framework’s XSS protection and appropriately handle the use cases which are not covered.
- Escaping untrusted HTTP request data based on the context in the HTML output (body, attribute, JavaScript, CSS, or URL) will resolve Reflected and Stored XSS vulnerabilities.
- Applying context-sensitive encoding when modifying the browser document on the client side acts against DOM XSS. 

## Documentation

- [OWASP - xss](https://cheatsheetseries.owasp.org/cheatsheets/Cross_Site_Scripting_Prevention_Cheat_Sheet.html)
- [OWASP - TOP 10 - xss](https://owasp.org/www-project-top-ten/2017/A7_2017-Cross-Site_Scripting_(XSS).html)
- [OWASP - xss filter evasion](https://owasp.org/www-community/xss-filter-evasion-cheatsheet)
- [bypass xss filters](https://www.paladion.net/blogs/bypass-xss-filters-using-data-uris)